var _init_once = false;

function _inject(w){
  if (!_init_once) {
    _init_once = true;
    addEventListener('message', function(param) {
      console.log('inner message: ', param, ', param.data: ', JSON.stringify(param.data));
      if (param.data) {
        const data = param.data;
        if (data.type.startsWith('tt_')) {
          if (data.type === 'tt_setSpeed') {
            setSpeed(data.speed);
          } else if (data.type === 'tt_setEnable') {
            setEnable(data.enable);
          }
        }
      }
    }, false);
  }

  w.log = function(msg) {
    if (!w.bridge) {
      console.log('why bridge is null');
    } else {
      console.log(msg);
      w.bridge.log(msg);
    }
  };

  if (w.__speed !== null && w.__speed !== undefined) {
    w.__speed = 1.0;
  }
  console.log('set _now to ' + Date.now)
  Date._now = Date._now || Date.now;
  w.__beginTime = Date._now();
  console.log('__beginTime: ', w.__beginTime);

  function setSpeed(speed) {
    console.log('set speed called')
    w.__speed = speed;
  }

  w.setSpeed = setSpeed;

  function setEnable(enable) {
    w.__enable_speed = enable;
  }
  w.setEnable = setEnable;

  Date.now = function() {
    const enable = w.__enable_speed !== false;
    if (enable) {
      return w.__beginTime + (Date._now() - w.__beginTime) * (w.__speed || 1.0);
    } else {
      return Date._now();
    }
  };
}

_inject(window);
console.log('inject_content called finish!!');
